using System;
using System.Text.Json.Serialization;
namespace org.accordproject.iot {
   using concerto;
   enum ClickType {
      SINGLE,
      DOUBLE,
      LONG,
   }

   abstract class GenericButtonPress : Transaction {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.iot.GenericButtonPress";
      public string serialNumber { get; set; }
      public string batteryVoltage { get; set; }
   }
   class ButtonPress : GenericButtonPress {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.iot.ButtonPress";
      public ClickType clickType { get; set; }
   }
   class SingleButtonPress : GenericButtonPress {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.iot.SingleButtonPress";
   }
   class DoubleButtonPress : GenericButtonPress {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.iot.DoubleButtonPress";
   }
   class LongButtonPress : GenericButtonPress {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.iot.LongButtonPress";
   }
}
